                     p586
                     model flat, stdcall
                     jumps
                     locals __
                     
                     include       ..\..\include\myapis.inc
                     include       ..\..\include\razno.inc
                     include       ..\..\include\useful.inc
                     include       ..\..\include\mz.inc
                     include       ..\..\include\pe.inc

                     .data
                     
                     db     ?
                     
                     align 4
                     
                     .code
              
start:               align  4
                     
                     @build_UNICODE_STRING <user32.dll>
                     xchg          esi, eax
                     
                     mov           eax, dword ptr fs:[30h]
                     mov           eax, [eax+0ch]
                     mov           eax, [eax+1ch]
                     mov           ebx, [eax+8]                              ; uzmi bazu od ntdll.dll
                     
                     gethash      <LdrLoadDll>
                     push          hash
                     call          load_dll_address
                     
                     xor           ebx, ebx
                     push          esp
                     push          esi
                     push          ebx
                     push          ebx
                     call          eax
                     pop           ebp                                       ; baza od user32.dll

                     xor           edx, edx
                     push          edx
                     push          esp
                     push          ebx
                     @sysenter     NtUserOpenClipboard, 2
                     pop           edx
                     test          eax, eax
                     jz            greska
                                          
                     push          MAXIMALNA_VELICINA_BF_POLJA+1
                     mov           edx, esp
                     xor           eax, eax                                  ; neka nam sistem dodijeli baznu adresu
                     push          eax
                     mov           ecx, esp
                     
                     push          PAGE_READWRITE                                         ;
                     push          MEM_COMMIT
                     push          edx
                     push          ebx                                       ; ZeroBits, 0 uvijek?
                     push          ecx                                       ; bazna adresa kako nam se dodijeli..
                     push          -1                                        ; trenutni proces
                     @sysenter     NtAllocateVirtualMemory, 6
                     pop           esi                                       ; bazna adresa koju smo dobili
                     pop           ecx                                       ; poravnaj stog
                     
                     test          eax, eax
                     jnz           greska
                     push          esi                                       ; za kasnije
                     
                     push          MAXIMALNA_VELICINA_STDOUT+1
                     mov           edx, esp
                     xor           eax, eax                                  ; neka nam sistem dodijeli baznu adresu
                     push          eax
                     mov           ecx, esp
                     
                     push          PAGE_READWRITE
                     push          MEM_COMMIT
                     push          edx
                     push          ebx                                         ; ZeroBits, 0 uvijek?
                     push          ecx                                       ; bazna adresa kako nam se dodijeli..
                     push          -1                                        ; trenutni proces
                     @sysenter     NtAllocateVirtualMemory, 6
                     pop           esi                                       ; bazna adresa koju smo dobili
                     pop           ecx                                       ; poravnaj stog

                     test          eax, eax
                     jnz           greska
                     push          esi                                       ; za kasnije
                     
                     push          CF_TEXT                                    ; je li na clipboardu tekst?
                     @sysenter     NtUserIsClipboardFormatAvailable, 1
                     xchg          eax, ecx
                     jecxz         zatvori_clip  

                     push          ebx
                     push          ebx
                     push          ebx
                     push          esp                                             ; ptr na neku gubavu strukturu od 3 DWORD-a
                     push          CF_TEXT
                     @sysenter     NtUserGetClipboardData, 2                       ; uzmi handle na clipboard
                     test          eax, eax
                     jz            zatvori_clip                                    ; vraca handle, NULL u slucaju greske
                     add           esp, 4*3                                        ; pocisti stog, vraca tip koji *jest* dostupan
                     
                     mov           edi, eax
                     
                     ; push eax
                     ; call user32!CreateLocalMemHandle
                     push          ebx                     
                     push          esp                                              ; 0 ili ako je buffer premal potrebna velicina buffera
                     push          ebx                                                ; velicina alocirane memorije
                     push          ebx                                                ; ptr na alociranu memoriju
                     push          eax                                              ; handle koji je vratio NtUserGetClipboardData
                     @sysenter     NtUserCreateLocalMemHandle, 4
                     
                     ;pop           edx                                             ; potrebna velicina buffera, mislim da vraca alociranu velicinu
                     mov           edx, esp                                         ; ptr na potrebnu velicinu buffera
                     xor           ecx, ecx
                     push          ecx                                              ; neka nam sistem dodijeli baznu adresu
                     mov           ecx, esp

                     push          PAGE_READWRITE
                     push          MEM_COMMIT
                     push          edx
                     push          ebx                                         ; ZeroBits, 0 uvijek?
                     push          ecx                                       ; bazna adresa kako nam se dodijeli..
                     push          -1                                        ; trenutni proces
                     @sysenter     NtAllocateVirtualMemory, 6
                     
                     pop           esi                                       ; bazna adresa koju smo dobili
                     pop           ecx                                       ; poravnaj stog! neka na stogu ostane velicina alocirane memorije

                     test          eax, eax
                     jnz           greska
                     
                     push          ebx
                     push          ecx
                     push          esi                                       ; esi = ptr na clipboard buffer
                     push          edi
                     @sysenter     NtUserCreateLocalMemHandle, 4

                     pop           edi
                     pop           ebp
                     
                     ; esi = ptr na ulazni niz
                     ; edi = ptr na stdout
                     ; ebp = p
                     
MAXIMALNA_VELICINA_PROGRAMA               equ           1024
MAXIMALNA_VELICINA_BF_POLJA               equ           30000-1
MAXIMALNA_VELICINA_STDOUT                 equ           500-1
                     
                     call          brainfuck_provjeri_sintaksu, esi
                     test          eax, eax
                     jz            __oslobodi
                     
__nastavi:           call          brainfuck_simuliraj, esi, ebp, edi
                     
			xor	       eax, eax				              ; inicijalizacija hasha

__1:			rol	       eax, 7
			xor	       al, [edi]
			inc	       edi					              ; slovo po slovo
			cmp	       byte ptr [edi], 0
			jnz	       __1
                     
                     gethash       <phearless in da haus>
                     mov           ebx, hash
                     xor           ebx, eax
                     jnz           greska
                     
                     ; oh joy, we're being cracked! :o)
                     
                     ; pozovi KeBugCheckEx sa stop kodom 0x600DC0DE

__izadji_normalno:   
__oslobodi:          push          MAXIMALNA_VELICINA_STDOUT+1
                     mov           edx, esp
                     push          edi
                     mov           ecx, esp

                     push          MEM_RELEASE
                     push          edx
                     push          ecx
                     push          -1
                     @sysenter     NtFreeVirtualMemory, 4
                     add           esp, 8
                     test          eax, eax
                     jnz           greska                     

__free_bf:           push          MAXIMALNA_VELICINA_BF_POLJA+1
                     mov           edx, esp
                     push          ebp
                     mov           ecx, esp
                     
                     push          MEM_RELEASE
                     push          edx
                     push          ecx
                     push          -1
                     @sysenter     NtFreeVirtualMemory, 4
                     add           esp, 8
                     test          eax, eax
                     jnz           greska
                     
zatvori_clip:        @sysenter     NtUserCloseClipboard, 0
                     
                     jmp           kraj                     
                     
greska:              int 3

kraj:                push          ebx
                     push          -1
                     @sysenter     NtTerminateProcess, 2


brainfuck_provjeri_sintaksu        proc   pascal      uses ebx

                     arg           p
   		
       		mov	       ecx, p
       		mov	       eax, ecx
       		jmp	       __petljaj

__loop:	       movsx	       edx, byte ptr [eax]
       		cmp	       edx, '+'
       		jz	       __ok_znak
       		cmp	       edx, '-'
       		jz	       __ok_znak
       		cmp	       edx, '<'
       		jz	       __ok_znak
       		cmp	       edx, '>'
       		jz	       __ok_znak
       		cmp	       edx, '['
       		jz	       __ok_znak
       		cmp	       edx, ']'
       		jz	       __ok_znak
       		cmp	       edx, '.'
       		jz	       __ok_znak
       		xor	       eax, eax
       		jmp	       __izlaz

__ok_znak:	       inc	       eax

__petljaj:	       cmp	       byte ptr [eax], 0
       		jnz	       __loop
       		
       		xor	       ebx, ebx                                  ; sad provjeravamo da li u polju ima neuparenih '[' i ']'
       		mov	       eax, ecx
       		jmp	       __1

__zagrade:	       movsx	       ecx, dl
       		cmp	       ecx, '['
       		jnz	       __3
       		inc	       ebx

__3:   	       cmp	       ecx, ']'
       		jnz	       __2
       		dec	       ebx

__2:		       inc	       eax

__1:		       mov	       dl, [eax]
       		test	       dl, dl
       		jnz	       __zagrade
       		test	       ebx, ebx
       		jz	       __ok_izlaz
       		xor	       eax, eax
       		jmp	       __izlaz

__ok_izlaz:	       mov	       eax, 1

__izlaz:	       ret
		
brainfuck_provjeri_sintaksu endp

brainfuck_simuliraj         proc   pascal      uses ebx esi edi

                     arg           clip
                     arg           polje
                     arg           stdout_polje
              
                     local         len
                     local         bf_stdout
              
         		xor	       eax, eax
    
       		mov	       edx, clip
       		mov	       len, eax
       		xor	       eax, eax
       		jmp	       __tmp

__1:		       inc	       len
		       inc	       eax

__tmp:		       cmp	       eax, MAXIMALNA_VELICINA_PROGRAMA
       		jge	       __chk_len
       		cmp	       byte ptr [edx+eax], 0
       		jnz	       __1

__chk_len:	       cmp	       len, MAXIMALNA_VELICINA_PROGRAMA-1
       		jnz	       __len_ok
       		xor	       eax, eax
       		jmp	       __izlaz

__len_ok:	       mov	       ecx, stdout_polje
       		xor	       esi, esi
       		mov	       bf_stdout, ecx
       		xor	       ecx, ecx
       		xor	       eax, eax
       		cmp	       eax, len
       		jge	       __izlaz1

__loop:	       movsx	       ebx, byte ptr [edx+eax]
       		cmp	       ebx, '+'
       		jnz	       __2
       		mov	       ebx, polje
       		inc	       byte ptr [ebx+esi]
       		jmp	       __provjera

__2:		       movsx	       ebx, byte ptr [edx+eax]
       		cmp	       ebx, '-'
       		jnz	       __3
       		mov	       ebx, polje
       		dec	       byte ptr [ebx+esi]
       		jmp	       __provjera

__3:		       movsx	       ebx, byte ptr [edx+eax]
       		cmp	       ebx, '>'
       		jnz	       __4
       		inc	       esi
       		jmp	       __provjera

__4:		       cmp	       ebx, '<'
       		jnz	       __5
       		dec	       esi
       		jmp	       __provjera

__5:		       cmp	       ebx, '['
       		jnz	       __6
       		mov	       ebx, polje
       		cmp	       byte ptr [ebx+esi], 0
       		jnz	       __provjera
       		inc	       eax
       		jmp	       __loopie

__pici_naprid:
                     movsx	       ebx, byte ptr [edx+eax]
       		cmp	       ebx, '['
       		jnz	        __shittie
       		inc	       ecx

__shittie:    	cmp	       ebx, ']'
       		jnz	        __y
       		dec	       ecx

__y:    	       inc	       eax

__loopie:     	test	       ecx, ecx
       		jg	       __pici_naprid
       		movsx	       ebx, byte ptr [edx+eax]
       		cmp	       ebx, ']'
       		jnz	       __pici_naprid
       		jmp	       __provjera

__6:   		movsx	       ebx, byte ptr [edx+eax]
       		cmp	       ebx, ']'
       		jnz	       __7
       		dec	       eax
       		jmp	       __loopie2


__naprid_jos:
       		movsx	       ebx, byte ptr [edx+eax]
       		cmp	       ebx, ']'
       		jnz	       __z
       		inc	       ecx

__z:	       	cmp	       ebx, '['
		       jnz	       __temp
		       dec	       ecx

__temp:	       dec	       eax

__loopie2:	       test	       ecx, ecx
       		jg	       __naprid_jos
       		movsx	       ebx, byte ptr [edx+eax]
       		cmp	       ebx, '['
       		jnz	       __naprid_jos
       		dec	       eax
       		jmp	       __provjera

__7:		       movsx	       ebx, byte ptr [edx+eax]
       		cmp	       ebx, '.'
       		jnz	       __provjera
       		mov	       ebx, polje
       		mov	       edi, bf_stdout
       		mov	       bl, [ebx+esi]
       		mov	       [edi], bl
       		inc	       bf_stdout

__provjera:	       inc	       eax
       		cmp	       eax, len
       		jl	       __loop

__izlaz1:	       mov	       eax, 1

__izlaz:	       ret
		
brainfuck_simuliraj endp


; ---------------------------------------------------------------------------
; searches for the address of specified API by export table scanning
; i: ebx = dll imagebase
;    TOS = API hash
;
; o: eax = API's address, 0 on error
; ---------------------------------------------------------------------------
load_dll_address:	pusha

			mov	       ecx, [ebx.MZ_lfanew]			; take RVA of PE header
			mov	       ecx, [ecx+ebx.NT_OptionalHeader.OH_DirectoryEntries.DE_Export.DD_VirtualAddress]
			jecxz	       __err					; check whether there is export directory RVA

			add	       ecx, ebx				; if so, normalize with imagebase
			xor	       esi, esi				; initialize counter
__k_l:			lea	       edx, [4*esi+ebx]
			add	       edx, [ecx.ED_AddressOfNames]	; take ptr to array of ptrs to functions names
			mov	       edx, [edx]				; take RVA of ptr to name of the API
			add	       edx, ebx				; normalize
			xor	       eax, eax				; initialize hash

__1:			rol	       eax, 7					; hash algo starts here. (x) by z0mbie
			xor	       al, [edx]
			inc	       edx					; next letter
			cmp	       byte ptr [edx], 0			; end of name?
			jnz	       __1					; nope, repeat again

			cmp	       eax, [esp.cPushad.Arg1]	       ; compare it with given hash; skip pushad+call+param
			jz	       __bingo				; yippie
       
			inc	       esi					; counter++
			cmp	       esi, [ecx.ED_NumberOfNames]		; compare counter with the number of exported functions
			jb	       __k_l					; if below, repeat it

__err:			xor	       eax, eax				; either exception occured, or we didn't find API. either way, set return value to false
			jmp	       __end

__bingo:		mov	       edx, [ecx.ED_AddressOfOrdinals]	; take RVA to array of API ordinals
			add	       edx, ebx				; normalize
			movzx	       edx, word ptr [edx+esi*2]		; x2 coz its an array of WORDs
			;sub	       edx, [ecx.ED_BaseOrdinal]
			mov	       eax, [ecx.ED_AddressOfFunctions]	; take RVA of an array of APIs addresses
			add	       eax, ebx				; normalize
			mov	       eax, [eax+edx*4]			; x4 coz its an array of DWORDs
			add	       eax, ebx				; normalize

__end:			mov	       [esp.Pushad_eax],eax			; set return address
			popa

                     retn          (Pshd)
end start
